#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <io.h>

#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>

#include <malloc.h>
#include <dos.h>
#include <graph.h>

#include "mode.h"
#include "vga.h"
#include "pmtext.h"

#include "at200.h"
#include "idecls.h"
#include "camsys.h"
#include "proto.h"
#include "bitmap.h"


/* Globals */

unsigned int img_data[2][512];		/* Raw input image */
unsigned char far pic0[256][256];		/* 256X256 by 64 level image */
unsigned char far pic1[256][256];

unsigned char far *image0;
unsigned char far *image1;
int window_shift0, window_shift1;


pv_ptr view ( register pv_ptr p )	
{
int x, y, dx, dy, sav_camera;
int page = 0;
int color = 150;

	if ( textmode )		/* If in text mode don't do display. */
	    return p;
	/* Returns pointer to EMS first page frame. */

	ems_data = (unsigned far *) ems_get_page_frame(); 
	if( !ems_data ) 
	{
		sprintf( omsg, "Unable to locate EMS page frame. Unable to proceed.\n");
		disp_omsg( ERROR );
		return p;
	}
   
	image0 = &pic0[0][0];	image1 = &pic1[0][0];

	sav_camera = sel_cam;	/* Save selected camera number. */

	memset( histogram, 0, 512*sizeof( long ) );
	select_camera( 0 );
	scan_image( &pic0[0][0], &window_shift0 );
	
	select_camera( 1 );
	scan_image( &pic1[0][0], &window_shift1 );
	clear();

	x = y = 0;
//	dx = sel_exp->cols/sel_exp->sbin;
//	dy = sel_exp->rows/sel_exp->pbin;
	dx = sel_hdr->structs.exp.cols/sel_hdr->structs.exp.sbin;
	dy = sel_hdr->structs.exp.rows/sel_hdr->structs.exp.pbin;
	
	dx = ( dx > 256 ) ? 256 : dx;
	dy = ( dy > 256 ) ? 256 : dy;
	if ( dx == 128 ){
		x = 63;
		y = 63;
	}
	
/*   disable_refresh();*/
	Write_Video( x, y, dx, dy, image1 );	/* Display first image. */
	select_camera( 0 );
	
//	dx = sel_exp->cols/sel_exp->sbin;
//	dy = sel_exp->rows/sel_exp->pbin;
	dx = sel_hdr->structs.exp.cols/sel_hdr->structs.exp.sbin;
	dy = sel_hdr->structs.exp.rows/sel_hdr->structs.exp.pbin;

	dx = ( dx > 256 ) ? 256 : dx;
	dy = ( dy > 256 ) ? 256 : dy;
	x = 384;
	if ( dx == 128 ){
		x = 448;
		y = 63;
	}
	Write_Video( x, y, dx, dy, image0 );	/* Then second. */
	drawhistogram( 0 ); drawhistogram( 1 );
	
	overlay_text( color );			/* Put in text. */
	draw_frames();				/* Frame the whole thing. */

	select_camera( 0 );
	annotate( color );

	select_camera( 1 );
	annotate( color );
	
	display_temps();
	
/*   enable_refresh();*/
   
	select_camera( sav_camera );		/* re-select current camera. */
	return p;
}


void drawhistogram( int camera )
{
unsigned int i, y, length;
unsigned int xstart, xend, color;
unsigned long max;

y = 256; max = 0L;
for ( i = 0; i < 256; i++ )
	max = ( max > histogram[camera][i] ) ? max : histogram[camera][i];
if ( max == 0 )
	return;
i = 0;

if ( camera == 1)
{
	color = 67; xend = 320;
	while ( y-- )
	{
	    length = (unsigned int)( (histogram[ 1 ][ i++ ] << 6)/ max);
	    xstart = xend - length;
	    Draw_HLine( xstart, xend, y, (char) color );
	}
}
else
{
	color = 75; xstart = 320;
	while ( y-- )
	{
	    length = (unsigned int)( (histogram[ 0 ][ i++ ] << 6)/ max);
	    xend = xstart + length;
	    Draw_HLine( xstart, xend, y, (char) color );
	}
}
}				
	
	


void draw_frames()
{
char color = 163;
int n, x, y;

	Draw_HLine( 0, 256, 0, color );
	Draw_HLine( 384, 639, 0, color );
	Draw_HLine( 0, 639, 255, color );
	Draw_HLine( 0, 639, 479, color );
	Draw_VLine( 0, 0, 479, color );
	Draw_VLine( 639, 0, 479, color );
	
	Draw_VLine( 256, 0, 255, color );
	Draw_VLine( 319, 256, 467, color );
	Draw_VLine( 383, 0, 255, color );
	Draw_VLine( 42, 256, 467, color );
	Draw_VLine( 362, 256, 467, color );
	Draw_HLine( 0, 639, 467, color );

/* Draw the vertical lines indicating 15 min. intervals on the temperature display */	

	for ( x = 319 - 900/sampleinterval; x > 42; x -= 900/sampleinterval )
	   for ( y = 257; y < 467; y += 15 )
	      Draw_VLine( x, y, y + 10, color );

	for ( x = 638 - 900/sampleinterval; x > 362; x -= 900/sampleinterval )
	   for ( y = 257; y < 467; y += 15 )
	      Draw_VLine( x, y, y + 10, color );
}


/* Read a camera image file, build 256 X 256 table of 8 bit pixel
 * intensity levels for display.  Accepts raw camera images of 512X512
 * (binning = 1) or 256X256 pixels (binning = 2).  
 */ 

void scan_image( unsigned char far *image, int * shift_val )
{
register unsigned row, col;
unsigned int	ix, y, x, z, bin, count, shifted_max, window_shift = 0;
unsigned long	temp, ems_x;
unsigned int pixel_min, pixel_max, image_sbin, image_pbin;
unsigned int image_rows, image_cols;
unsigned int page, pos;

entry_ptr localpv[5];
int next;

#ifdef SKIP
char my_line[] = "compare \"-exit\"";	/*  will provide 'compare' args */
	
	/* Call 'comp' command to do image scan for min and max values,
	 * and histogram values.
	 */
	 
	iparse( my_line, &localpv[0], &next );
	localpv[ next ] = NULL;
	iexec( localpv );
#endif

	/* Get image characteristics. */
	
	image_pbin = sel_exp->pbin;
	image_sbin = sel_exp->sbin;
	image_rows = sel_exp->rows;
	image_cols = sel_exp->cols;

	/* Check if image to be processed is at an acceptable binning factor. */

	bin = 0;
	if ( ( image_pbin == 1 ) && ( image_sbin == 1 ) )
		bin = 1;
	else if ( ( image_pbin == 2 ) && ( image_sbin == 2 ) )
		bin = 2;
	else if ( ( image_pbin == 4 ) && ( image_sbin == 4 ) )
		bin = 4;
	

	if ( !bin )
	{
		printf("ERROR: binning must be 1X1, 2X2, for image.\n");
		exit ( -1 );
	}	      

	y = image_rows / image_pbin;	/* y = actual # of pixels in y axis */
	x = image_cols / image_sbin;	/* x = actual # of pixels in x axis */

	/* Reset pixel min and max. */

	sel_misc->pixel_min = 32767;
	sel_misc->pixel_max = 0;

	/* Scan through EMS data once to get min and max pixel intensities. */

	for(	page = 0; 
        	page < (unsigned) ( 32 / ( image_sbin * image_pbin ) ); 
        	page++ ) 
	{
        	ems_map_page( 0, sel_misc->ems_handle, page );
		scan_histogram( ems_data, page, sel_cam );
	}
     
	pixel_min  = sel_misc->pixel_min;
	pixel_max  = sel_misc->pixel_max;

	shifted_max = pixel_max & 0x3FFF;
	while ( shifted_max > 64 ){
		shifted_max = ( shifted_max >> 1 );
		window_shift++;
	}

	*shift_val = window_shift;
	ix = 0;
	
	/* Process the input image data */

	ems_x = 0L;			/* index to int value in ems_data. */
	for( row=0; row<y; row++ )	/* Each row of image data */
	{
		/* 'pos' is the index to an word offset in ems_data.
		 * If zero, we are at the start of a new 16K (byte) page
		 */

		pos  = (unsigned int) ( ems_x % 8192L );
		if ( pos == 0 )
		{
			page = (unsigned int) ( ems_x / 8192L );
        		ems_map_page( 0, sel_misc->ems_handle, page );
		}
		
		/* Copy one row of camera data to img_data buffer. */	

	        memcpy ( &img_data[0][0], &ems_data[ pos ], x*2 );
	        ems_x += x;

		if ( bin == 1 )
		{
			/* If binning is one, we process two rows of
			 * camera data into one row of video pixels. 
			 */  	
	
			pos  = (unsigned int) ( ems_x % 8192L );
			if ( pos == 0 )
			{
				page = (unsigned int) ( ems_x / 8192L );
        			ems_map_page( 0, sel_misc->ems_handle, page );
			}
	        	memcpy ( &img_data[1][0], &ems_data[ pos ], x*2 );
	        	ems_x += x;
			row++;
		}

		/* Convert camera data to video image data. */
			
		for( temp = 0L, col=0; col<x; col++ )
		{
			temp = img_data[0][col];
			if ( bin == 1 )
				col++;
			temp = ( temp & 0x3FFFL ) >> window_shift;
			temp = ( temp > 63 ) ? 63 : temp;
			image[ix++] = (unsigned char)temp;
		}
	}
}



void overlay_text( int color )
{
char buf[16];

	/* First print all the labels that don't change */

	print_string( 1, 1, camera[ 1 ], (char) 112 );
	print_string( 384, 1, camera[ 0 ], (char) 112 );

	print_string( 1, 257, temperature[ FW ], (char) 112 );
	print_string( 1, 257 + 40, temperature[ INT ], (char) 64 );
	print_string( 1, 257 + 80, temperature[ DOME ], (char) 78 );
	print_string( 1, 257 + 120, temperature[ EXT ], (char) 70 );
	print_string( 1, 257 + 160, temperature[ CCD ], (char) 120 );

	print_string( 321, 257, temperature[ FW ], (char) 112 );
	print_string( 321, 257 + 40, temperature[ INT ], (char) 64 );
	print_string( 321, 257 + 80, temperature[ DOME ], (char) 78 );
	print_string( 321, 257 + 120, temperature[ EXT ], (char) 70 );
	print_string( 321, 257 + 160, temperature[ CCD ], (char) 120 );
	
		
	/* Then the ones that do change. */

	sprintf( buf, "%-d bits", window_shift1 );
	print_string( 207, 257 - 24, buf, (char) 109 );
	sprintf( buf, "%-d bits", window_shift0 );
	print_string( 591, 257 - 24, buf, (char) 109 );

	if ( std1_misc.exp_scale == 1000 ){
		sprintf( buf, "%d s", std1_exp.exposure );
		print_string( 1, 257 - 24, buf, (char)108 );
	}
	if ( std1_misc.exp_scale == 1 ){
		sprintf( buf, "%d ms", std1_exp.exposure );
		print_string( 1, 257 - 24, buf, (char)108 );
	}
	if ( std1_misc.exp_scale == 60000 ){
		sprintf( buf, "%d min", std1_exp.exposure );
		print_string( 1, 257 - 24, buf, (char)108 );
	}
	if ( std0_misc.exp_scale == 1000 ){
		sprintf( buf, "%d s", std0_exp.exposure );
		print_string( 385, 257 - 24, buf, (char)108 );
	}
	if ( std0_misc.exp_scale == 1 ){
		sprintf( buf, "%d ms", std0_exp.exposure );
		print_string( 385, 257 - 24, buf, (char)108 );
	}
	if ( std0_misc.exp_scale == 60000 ){
		sprintf( buf, "%d min", std0_exp.exposure );
		print_string( 385, 257 - 24, buf, (char)108 );
	}
	
	print_string( 1, 257 - 14, type[ (int)std1_misc.exposure_type ], (char) 112 );
	print_string( 385, 257 - 14, type[ (int)std0_misc.exposure_type ], (char) 112 );

	print_string( 215,1, std1_misc.filter_desc, (char) 112 );
	print_string( 599, 1, std0_misc.filter_desc, (char) 112 );
	
	print_string( 2, 467, date_c, (char) color );
	print_string( 150, 467, time_c, (char) color );
}



void annotate( int color )
{
char	date_str[20], time_str[20];
 
	sprintf( date_str, "%4d/%02d/%02d",
		sel_misc->dt.year,
		sel_misc->dt.month,
		sel_misc->dt.day );
	sprintf( time_str, "%02d:%02d:%02d",
		sel_misc->tm.hour,
		sel_misc->tm.minute,
		sel_misc->tm.second );
	print_string( 35, 467, date_str, (char) color );
	print_string( 185, 467, time_str, (char) color );
}



void scan_histogram ( unsigned far *emsdata, int page , int camera )
{
long total_pixels;
register unsigned min, max;
register unsigned i, val;

	min = sel_misc->pixel_min;	/* local for speed. */
	max = sel_misc->pixel_max;
	total_pixels = page * 8192;
		
	for ( i=0; i<8192; i++ )
	{
	if ( isbitset( bitmap, total_pixels ) ){
   		  val = emsdata[ i ] & 0x3FFF;
		  histogram[ camera ][ (val >> 6) ]++;
		  if ( val < min )
			min = val;
		  else if ( val > max )
			max = val;
		}
		total_pixels++;
	}
	sel_misc->pixel_min = min;
	sel_misc->pixel_max = max;
}



void display_temps( void )
{
  int x, count;  
  char tempbuf[8];
    
  count = sampleptr - 1;  
  if ( std0_misc.cam_opmode & 0x01 )
  {
  sprintf( tempbuf, "%+5.1f", (float)(t_history0[count].tfw)/10.0 );
  print_string( 321, 271, tempbuf, 112 );
  sprintf( tempbuf, "%+5.1f", (float)(t_history0[count].tei)/10.0 );
  print_string( 321, 271 + 40, tempbuf, 64 );
  sprintf( tempbuf, "%+5.1f", (float)(t_history0[count].td)/10.0 );
  print_string( 321, 271 + 80, tempbuf, 78 );
  sprintf( tempbuf, "%+5.1f", (float)(t_history0[count].tee)/10.0 );
  print_string( 321, 271 + 120, tempbuf, 70 );
  sprintf( tempbuf, "%+5.1f", (float)(t_history0[count].tcf)/10.0 );
  print_string( 321, 271 + 160, tempbuf, 120 );
  
     for ( x = 638; x > (638 - no_samples); x-- )
     {
      Write_Pixel( x, 376 - (t_history0[count].tei * 2)/5, 64 );
      Write_Pixel( x, 336 - (t_history0[count].tee * 2)/5, 70 );
      Write_Pixel( x, 376 - (t_history0[count].td * 2)/5, 78 );
      Write_Pixel( x, 376 - (t_history0[count].tfw * 2)/5, 112 );
      Write_Pixel( x, -44 - t_history0[count].tcf, 120 );
      count--;
      if ( count < 0 )
         count = MAX_SAMPLES;
      }
   }

   count = sampleptr - 1;  
   if ( std1_misc.cam_opmode & 0x02 )
   {
   sprintf( tempbuf, "%+5.1f", (float)(t_history1[count].tfw)/10.0 );
   print_string( 1, 271, tempbuf, 112 );
   sprintf( tempbuf, "%+5.1f", (float)(t_history1[count].tei)/10.0 );
   print_string( 1, 271 + 40, tempbuf, 64 );
   sprintf( tempbuf, "%+5.1f", (float)(t_history1[count].td)/10.0 );
   print_string( 1, 271 + 80, tempbuf, 78 );
   sprintf( tempbuf, "%+5.1f", (float)(t_history1[count].tee)/10.0 );
   print_string( 1, 271 + 120, tempbuf, 70 );
   sprintf( tempbuf, "%+5.1f", (float)(t_history1[count].tcf)/10.0 );
   print_string( 1, 271 + 160, tempbuf, 120 );
     for ( x = 318; x > (318 - no_samples); x-- )
     {
      Write_Pixel( x, 376 - (t_history1[count].tei * 2)/5, 64 );
      Write_Pixel( x, 336 - (t_history1[count].tee * 2)/5, 70 );
      Write_Pixel( x, 376 - (t_history1[count].td * 2)/5, 78 );
      Write_Pixel( x, 376 - (t_history1[count].tfw * 2)/5, 112 );
      Write_Pixel( x, -44 - t_history1[count].tcf, 120 );
      count--;
      if ( count < 0 )
         count = MAX_SAMPLES;
      }
   }
}
   
